SortBy and SortedBy sometimes give wrong result
Status: Closed Start date: 29 Apr 2019

Priority: Urgent Due date:  

Assignee: John Abbott % Done: 100%

Category: bug Estimated time: 1.55 hour

Target version: CoCoA-5.3.0 Spent time: 1.40 hour

Description

In CoCoA5 the SortBy and SortedBy functions sometimes give wrong answers!

Here is an example:

L := [8,  2,  9,  10,  15,  3,  1,  14,  5,  11,  13,  4,  16,  17,  6,  12,  7];

SortedBy(L, func(a,b) return a<b; endfunc);

[1,  2,  4,  5,  6,  3,  7,  8,  9,  10,  11,  12,  13,  14,  15,  16,  17]

 

Ouch!

Note: reported by Julian Danner (Passau)

History

#1 - 29 Apr 2019 14:56 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Example found by calling SortedBy on random permutations of 1..17.

Seems to work find for lists with only 16 or fewer elements.

The sorting impl calls InsertionSortBy when the list is shorter than 16.

#2 - 29 Apr 2019 15:26 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 10 to 70

The bug was at the end of the first loop in QuickSortBy1 where the case Up = Down was not handled.

Added 1 line; seems OK now.  Will check in ASAP.

Updated exbugs.cocoa5 too.

#3 - 30 Apr 2019 10:37 - John Abbott

- Description updated

- Estimated time set to 1.55 h
#4 - 04 Jun 2019 17:26 - Anna Maria Bigatti

can you send me the line you added?

#5 - 11 Oct 2019 22:02 - John Abbott

- Status changed from Resolved to Closed

- % Done changed from 70 to 100

This was actually fixed some time ago; I just forgot to tell redmine.
